<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | 45.40</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">DANH SÁCH NGƯỜI DÙNG ĐĂNG KÝ</a>
      </li>
    </ul>

  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">QuanNM</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>DANH SÁCH NGƯỜI DÙNG ĐĂNG KÝ</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>DANH SÁCH NGƯỜI DÙNG ĐĂNG KÝ</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">DANH SÁCH NGƯỜI DÙNG ĐĂNG KÝ</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="text-center">
            <h2>DANH SÁCH NGƯỜI DÙNG ĐĂNG KÝ</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
    </div>
      <!-- Vouche Data Table -->
    <div class="container-fluid">
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>

    <!-- Vùng Modal -->

    <!-- Create voucher modal -->
    <div>
        <div id="add-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Thêm User</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-firstname">Firstname: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-firstname" name="firstname" placeholder="Firstname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-lastname">Lastname: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-lastname" name="lastname" placeholder="Lastname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-subject">Subject: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-subject" name="subject" placeholder="Subject" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="select-create-country">Country: </label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-create-country" name="country" class="form-control">
                                    <option value="0">Chọn country</option>
                                    <option value="VN">Việt Nam</option>
                                    <option value="USA">USA</option>
                                    <option value="AUS">Australia</option>
                                    <option value="CAN">Canada</option>
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary" id="btn-modal-add-user">Add User</button>
                </div>
                </div>
            </div>
        </div>
    </div>


    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Update User</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-firstname">Firstname: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-firstname" name="firstname" placeholder="Firstname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-lastname">Lastname: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-lastname" name="lastname" placeholder="Lastname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-subject">Subject: </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-subject" name="subject" placeholder="Subject" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="select-update-country">Country: </label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-country" name="country" class="form-control">
                                    <option value="0">Chọn country</option>
                                    <option value="VN">Việt Nam</option>
                                    <option value="USA">USA</option>
                                    <option value="AUS">Australia</option>
                                    <option value="CAN">Canada</option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="select-update-customer-type">Customer Type: </label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-customer-type" name="customerType" class="form-control">
                                    <option value="Standard">Standard</option>
                                    <option value="Gold">Gold</option>
                                    <option value="Premium">Premium</option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="select-update-register-status">Register Status: </label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-register-status" name="registerStatus" class="form-control">
                                    <option value="Gold">Gold</option>
                                    <option value="Accepted">Accepted</option>
                                    <option value="Denied">Denied</option>
                                    <option value="Standard">Standard</option>
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary" id="btn-modal-update-user">Update User</button>
                </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

<script>
  "use strict";
  $(document).ready(function() {
      // Vùng 1: Vùng khai báo biến toàn cục
      const gBASE_URL = "http://42.115.221.44:8080/crud-api/users/";
      const gUSERS_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
      const gID_COL = 0;
      const gFIRST_NAME_COL = 1;
      const gLAST_NAME_COL = 2;
      const gCOUNTRY_COL = 3;
      const gSUBJECT_COL = 4;
      const gCUSTOMER_TYPE_COL = 5;
      const gREGISTER_STATUS_cOL = 6;
      const gACTION_COL = 7;

      var gCountryObjects = [
          {
              "value": "VN",
              "text": "Việt Nam"
          },
          {
              "value": "USA",
              "text": "USA"
          },
          {
              "value": "AUS",
              "text": "Australia"
          },
          {
              "value": "CAN",
              "text": "Canada"
          }
      ];
      var gListUsers = [];

      var gUserTable = $('#user-table').DataTable({
              columns: [
                  { data: gUSERS_COLS[gID_COL] },
                  { data: gUSERS_COLS[gFIRST_NAME_COL] },
                  { data: gUSERS_COLS[gLAST_NAME_COL] },
                  { data: gUSERS_COLS[gCOUNTRY_COL] },
                  { data: gUSERS_COLS[gSUBJECT_COL] },
                  { data: gUSERS_COLS[gCUSTOMER_TYPE_COL] },
                  { data: gUSERS_COLS[gREGISTER_STATUS_cOL] },
                  { data: gUSERS_COLS[gACTION_COL] }
              ],
              columnDefs: [
                  {
                      targets: gCOUNTRY_COL,
                      render: function(data) {
                          return getCountryTextByCountryValue(data);
                      }
                  },
                  {
                      targets: gACTION_COL,
                      defaultContent: "<button class='btn btn-primary' id='btn-edit'>Sửa</button>" + "<button class='btn btn-danger' id='btn-delete'>Xóa</button>"
                  }
              ]
          });

      var gUserId = 0;

      // Vùng 2: Vùng gán
      onPageLoading();

      $(document).on('click', '#user-table #btn-edit', function() {
          onBtnEditUserClick(this);
      });
      $('#btn-modal-update-user').on('click', onBtnModalUpdateUserClick);

      $(document).on('click', '#user-table #btn-delete', function() {
          onBtnDeleteUserClick(this);
      });
      $('#btn-confirm-delete-user').on('click', onBtnModalConfirmDeleteUserClick);

      $('#btn-add-user').on('click', onBtnAddUserClick);
      $('#btn-modal-add-user').on('click', onBtnModalAddUserClick);

      // Vùng 3: Vùng khai báo hàm xử lý sự kiện
      // Hàm xử lý khi tải trang
      function onPageLoading() {
          "use strict";
          console.log("Tải trang");
          // Gọi API
          callApiGetAllUsers();
          loadDataToTable(gListUsers);
      }

      // Hàm xử lý khi ấn nút Sửa
      function onBtnEditUserClick(paramEle) {
          "use strict";
          //console.log("Sửa");
          var vRowClick = $(paramEle).closest('tr');
          var vTable = $('#user-table').DataTable();
          var vDataRow = vTable.row(vRowClick).data();
          console.log("Sửa User có ID: " + vDataRow.id);
          console.log(vDataRow);
          // Hiện modal update
          $('#update-user-modal').modal("show");
          // Lưu thông tin user id đang đc update vào biến toàn cục
          gUserId = getUserIdFromButton(paramEle);
          // Load dữ liệu vào các trường trên modal update
          showUserDataToModal(gUserId);
      }

      // Hàm xử lý khi ấn nút Xóa
      function onBtnDeleteUserClick(paramEle) {
          "use strict";
          //console.log("Xóa");
          var vRowClick = $(paramEle).closest('tr');
          var vTable = $('#user-table').DataTable();
          var vDataRow = vTable.row(vRowClick).data();
          console.log("Xóa User có ID: " + vDataRow.id);
          console.log(vDataRow);
          gUserId = vDataRow.id;
          // Hiện modal confirm delete
          $('#delete-confirm-modal').modal("show");
      }

      // Hàm xử lý khi thêm user được click
      function onBtnAddUserClick() {
          "use strict";
          console.log("Add user");
          $('#add-user-modal').modal("show");
      }

      // Hàm xử lý khi button Add User trong modal được click
      function onBtnModalAddUserClick() {
          "use strict";
          // B0: Tạo đối tượng lưu trữ dữ liệu
          var vUserObj = {
              firstname: "",
              lastname: "",
              subject: "",
              country: ""
          };
          // B1: Thu thập dữ liệu từ input modal
          getDataFromModalAddUserInput(vUserObj);
          //console.log(vUserObj);
          // B2: Validate dữ liệu
          var vIsCheckUser = validateUser(vUserObj);
          console.log(vIsCheckUser);
          // Bước 3: Call api khi dữ liệu hợp lệ
          if (vIsCheckUser == true) {
              callApiPostNewUser(vUserObj);
              callApiGetAllUsers();
              loadDataToTable(gListUsers);
              resertAddUserForm();
              $("#add-user-modal").modal("hide");
          }
      }

      // Hàm xử lý khi button Update User trong modal được click
      function onBtnModalUpdateUserClick() {
          "use strict";
          // B0: Tạo đối tượng lưu trữ dữ liệu
          var vUserObj = {
              firstname: "",
              lastname: "",
              subject: "",
              country: "",
              customerType: "",
              registerStatus: ""
          };
          // B1: Thu thập dữ liệu từ input modal
          getDataFromModalUpdateUserInput(vUserObj);
          console.log(vUserObj);
          // B2: Validate dữ liệu
          var vIsCheckUser = validateUpdateUser(vUserObj);
          console.log(vIsCheckUser);
          // Bước 3: Call api khi dữ liệu hợp lệ
          if (vIsCheckUser == true) {
              callApiPutUser(vUserObj);
              callApiGetAllUsers();
              loadDataToTable(gListUsers);
              resertUpdateUserForm();
              $("#update-user-modal").modal("hide");
          }
      }

      // Hàm xử lý confirm delete user trong modal delete
      function onBtnModalConfirmDeleteUserClick() {
          "use strict";
          // B1: thu thập (k có)
          // B2: validate (k có)
          // B3: Call api delete
          callApiDeleteUser();
          // B4: xử lý front-end
          callApiGetAllUsers();
          loadDataToTable(gListUsers);
          $("#delete-confirm-modal").modal("hide");
      }

      // Vùng 4: Vùng khai báo hàm dùng chung
      // Hàm call api lấy data all users
      function callApiGetAllUsers() {
          "use strict";
          $.ajax({
              url: gBASE_URL,
              type: 'GET',
              dataType: 'json',
              async: false,
              success: function(result) {
                  //console.log(result);
                  gListUsers = result;
                  //console.log(gListUsers);
              },
              error: function(error) {
                  console.log(error.responseText);
              }
          });
      }

      // Hàm đổ dữ liệu vào table
      function loadDataToTable(paramObjectUsers) {
          "use strict";
         // console.log(paramObjectUsers);
          var vTable = $('#user-table').DataTable();
          vTable.clear();
          vTable.rows.add(paramObjectUsers);
          vTable.draw();
      }

      // Hàm lấy text country theo value
      function getCountryTextByCountryValue(paramCountry) {
          "use strict";
          var vTextCountry = "";
          for (var bI = 0; bI < gCountryObjects.length; bI++) {
              if (gCountryObjects[bI].value == paramCountry) {
                  vTextCountry = gCountryObjects[bI].text;
              }
          };
          return vTextCountry;
      }

      // Hàm thu thập dữ liệu từ input trong modal add user
      function getDataFromModalUpdateUserInput(paramUserObj) {
          "use strict";
          paramUserObj.firstname = $.trim($('#input-update-firstname').val());
          paramUserObj.lastname = $.trim($('#input-update-lastname').val());
          paramUserObj.subject = $.trim($('#input-update-subject').val());
          paramUserObj.country = $('#select-update-country').val();
          paramUserObj.customerType = $('#select-update-customer-type').val();
          paramUserObj.registerStatus = $('#select-update-register-status').val();
      }

      // Hàm thu thập dữ liệu từ input trong modal add user
      function getDataFromModalAddUserInput(paramUserObj) {
          "use strict";
          paramUserObj.firstname = $.trim($('#input-create-firstname').val());
          paramUserObj.lastname = $.trim($('#input-create-lastname').val());
          paramUserObj.subject = $.trim($('#input-create-subject').val());
          paramUserObj.country = $('#select-create-country').val();
      }

      // Hàm validate trong modal add user
      function validateUser(paramUserObj) {
          "use strict";
          if (paramUserObj.firstname === "") {
              alert("Chưa nhập firstname!");
              return false;
          }
          if (paramUserObj.lastname === "") {
              alert("Chưa nhập lastname!");
              return false;
          }
          if (paramUserObj.subject === "") {
              alert("Chưa nhập subject!");
              return false;
          }
          if (paramUserObj.country === "0") {
              alert("Chưa chọn country!");
              return false;
          }
          return true;
      }

      // Hàm validate trong modal update user
      function validateUpdateUser(paramUserObj) {
          "use strict";
          if (paramUserObj.firstname === "") {
              alert("Chưa nhập firstname!");
              return false;
          }
          if (paramUserObj.lastname === "") {
              alert("Chưa nhập lastname!");
              return false;
          }
          if (paramUserObj.subject === "") {
              alert("Chưa nhập subject!");
              return false;
          }
          if (paramUserObj.country === "0") {
              alert("Chưa chọn country!");
              return false;
          }
          if (paramUserObj.registerStatus === "Gold") {
              alert("Phải thay đổi Register Status!");
              return false;
          }
          return true;
      }

      // Hàm call api post new user
      function callApiPostNewUser(paramUserObj) {
          "use strict";
          $.ajax({
              url: gBASE_URL,
              type: 'POST',
              data: JSON.stringify(paramUserObj),
              dataType: 'json',
              contentType: "application/json;charset=UTF-8",
              async: false,
              success: function(result) {
                  alert("Đã tạo thành công user: " + Object.entries(result));
                  
              },
              error: function(error) {
                  console.log(error.responseText);
              }
          });
      }

      // Hàm call api put new user
      function callApiPutUser(paramUserObj) {
          "use strict";
          $.ajax({
              url: gBASE_URL + gUserId,
              type: 'PUT',
              data: JSON.stringify(paramUserObj),
              dataType: 'json',
              contentType: "application/json;charset=UTF-8",
              async: false,
              success: function(result) {
                  alert("Update thành công user: " + Object.entries(result));
              },
              error: function(error) {
                  console.log(error.responseText);
              }
          });
      }

      // Hàm call api delete new user
      function callApiDeleteUser() {
          "use strict";
          $.ajax({
              url: gBASE_URL + gUserId,
              type: 'DELETE',
              dataType: 'json',
              async: false,
              success: function(result) {
                  alert("Delete thành công user");
              },
              error: function(error) {
                  console.log(error.responseText);
              }
          });
      }

      // Hàm xóa trắng modal add user
      function resertAddUserForm() {
          "use strict";
          $("#input-create-firstname").val("");
          $("#input-create-lastname").val("");
          $("#input-create-subject").val("");
          $("#select-create-country").val("0");
      }

      // Hàm xóa trắng modal update user
      function resertUpdateUserForm() {
          "use strict";
          $("#input-update-firstname").val("");
          $("#input-update-lastname").val("");
          $("#input-update-subject").val("");
          $("#select-update-country").val("0");
          $("#select-update-customer-type").val("");
          $("#select-update-register-status").val("");
      }

      // hàm dựa vào button detail (edit or delete) xác định đc id voucher
      function getUserIdFromButton(paramButton) {
          "use strict";
          var vTableRow = $(paramButton).parents("tr");
          var vUserRowData = gUserTable.row(vTableRow).data();
          return vUserRowData.id;
      }

      // hàm show voucher obj lên modal
      function showUserDataToModal(paramUserId) {
          "use strict";
          var vUserIndex = getIndexFormUserId(paramUserId);
          $("#input-update-firstname").val(gListUsers[vUserIndex].firstname);
          $("#input-update-lastname").val(gListUsers[vUserIndex].lastname);
          $("#input-update-subject").val(gListUsers[vUserIndex].subject);
          $("#select-update-country").val(gListUsers[vUserIndex].country);
          $("#select-update-customer-type").val(gListUsers[vUserIndex].customerType);
          $("#select-update-register-status").val(gListUsers[vUserIndex].registerStatus);
      }

      // Hàm tìm user 
      function getIndexFormUserId(paramUserId) {
          "use strict"
          var vUserIndex = -1;
          var vUserFound = false;
          var vLoopIndex = 0;
          while(!vUserFound && vLoopIndex < gListUsers.length) {
              if(gListUsers[vLoopIndex].id === paramUserId) {
                  vUserIndex = vLoopIndex;
                  vUserFound = true;
              }
              else {
                  vLoopIndex ++;
              }
          }
          return vUserIndex;
      }

  });
</script>
</body>
</html>
